﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Windows.Forms.Grid;

namespace DataGrid
{
    public partial class Form1 : Form
    {
        DataTable dt;
        public Form1()
        {
            InitializeComponent();

            this.gridGroupingControl1.ShowGroupDropArea = true;
            //To resize the column based on length of cell value
            this.gridGroupingControl1.AllowProportionalColumnSizing = false;
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.AutoSize = true;
            this.gridGroupingControl1.TableDescriptor.Appearance.AnyRecordFieldCell.WrapText = false;
            this.gridGroupingControl1.TableModel.ColWidths.ResizeToFit(GridRangeInfo.Table());

            #region DataSource
            DataCollection dataSource = new DataCollection();
            Random rand = new Random();
            int r1 = rand.Next(1000);
            int r = rand.Next(100);
            for (int i = 0; i < 10; i++)
            {
                if (i >= 4 && i <= 6)
                {
                    dataSource.Add(new Data("4769548567765435654356765467", "" , "Descgergwefesdfedsvdfvxfdxdcvfedcfd" + r.ToString(), r.ToString() + "Data"));
                }
                else
                    dataSource.Add(new Data(i.ToString(), "" + r.ToString(), "Desc" + r.ToString(), r.ToString() + "Data"));
                r = rand.Next(100);
                r1 = rand.Next(1000);
            }
            this.gridGroupingControl1.DataSource = dataSource;
            dt = new DataTable();
            dt.Columns.Add("Name");
            dt.Columns.Add("Id");
            dt.Columns.Add("Amount", typeof(double));
            for (int i = 0; i < 500; i++)
            {
                DataRow dr = dt.NewRow();
                dr[0] = "E" + i.ToString(); 
                dr[1] = i;
                dr[2] = i;
                dt.Rows.Add(dr);
            }

            #endregion

           this.gridGroupingControl1.QueryCellStyleInfo += GridGroupingControl1_QueryCellStyleInfo;
        }

        private void GridGroupingControl1_QueryCellStyleInfo(object sender, GridTableCellStyleInfoEventArgs e)
        {
            e.Style.AutoSize = true;
            e.Style.WrapText = false;
        }
    }
}
